﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Sinuser extends Sprite
	{
		private var bmp:BitmapData;
		private var angle:uint = 30000;
		private var support:Sprite = new Sprite();
		private var filterObj:BlurFilter = new BlurFilter(1.2,1.2,1000000);
		private var colors:Array = [0x000fff,0xffff00];
		public function Sinuser()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmp = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			addChild(new Bitmap(bmp));
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function buildCycle(target:Sprite,angle:uint):Sprite
		{	
			var point:Sprite = new Sprite();
			point.graphics.beginFill(colors[angle%4],100);
			point.graphics.drawCircle(300,300,20);
			point.graphics.endFill();
			target.addChild(point);
			point.x = Math.cos(angle*Math.PI/360)*1;
			point.y = Math.sin(angle*Math.PI/360)*400;
			return point;
		}
		private function enterHandler(e:Event):void
		{
			var basis:Sprite = new Sprite();
			basis.x = stage.stageWidth/2;
			basis.y = stage.stageHeight/2;
			support.addChild(basis);
			for(var i:uint=0;i<50;i++){
				basis = buildCycle(basis,angle*i);
			}
			var m:Matrix = new Matrix();
			m.rotate(angle/1);
			m.translate(stage.stageWidth*2,stage.stageHeight*2);
			m.scale(0.25,0.25);
			if(angle%1000 == 0){
				bmp.applyFilter(bmp,bmp.rect,new Point(0,0),filterObj);
			}
			bmp.draw(support,m);
			support.removeChildAt(0);
			angle++;
		}
	}
}